#include "stdafx.h"
#include "FTPTransfer.h"
#include "FTPDlg.h"
#include "FTPTransferDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


#pragma warning(suppress: 26455)
CFTPDlg::CFTPDlg(_In_opt_ CWnd* pParent) : CDialog{CFTPDlg::IDD, pParent},
                                           m_bAscii{FALSE},
                                           m_dbLimit{0.0},
                                           m_bPasv{FALSE},
                                           m_dwConnectionTimeout{15000},
                                           m_nConnection{static_cast<int>(CFTPTransferer::ConnectionType::UsePreConfig)},
                                           m_dwSendTimeout{0},
                                           m_dwReceiveTimeout{0},
                                           m_hIcon{AfxGetApp()->LoadIcon(IDR_MAINFRAME)}
{
}

#pragma warning(suppress: 26429)
void CFTPDlg::DoDataExchange(CDataExchange* pDX)
{
  __super::DoDataExchange(pDX);
  DDX_Text(pDX, IDC_SERVER, m_sServer);
  DDX_Text(pDX, IDC_REMOTE, m_sRemote);
  DDX_Text(pDX, IDC_LOCAL, m_sLocal);
  DDX_Text(pDX, IDC_USER, m_sUserName);
  DDX_Text(pDX, IDC_PASSWORD, m_sPassword);
  DDX_CBIndex(pDX, IDC_CONNECTION, m_nConnection);
  DDX_Text(pDX, IDC_PROXY_STRING, m_sProxy);
  DDX_Text(pDX, IDC_LIMIT, m_dbLimit);
  DDV_MinMaxDouble(pDX, m_dbLimit, 0.0, 200000000.0);
  DDX_Text(pDX, IDC_CONNECTION_TIMEOUT, m_dwConnectionTimeout);
  DDX_Text(pDX, IDC_SEND_TIMEOUT, m_dwSendTimeout);
  DDX_Text(pDX, IDC_RECEIVE_TIMEOUT, m_dwReceiveTimeout);
  DDX_Check(pDX, IDC_ASCII, m_bAscii);
  DDX_Check(pDX, IDC_PASV, m_bPasv);
  if (pDX->m_bSaveAndValidate)
  {
    if (m_sServer.IsEmpty())
    {
      AfxMessageBox(_T("Please enter a valid server to transfer to/from"));
      pDX->PrepareEditCtrl(IDC_SERVER);
      pDX->Fail();
    }
    if (m_sRemote.IsEmpty())
    {
      AfxMessageBox(_T("Please enter a valid remote file"));
      pDX->PrepareEditCtrl(IDC_REMOTE);
      pDX->Fail();
    }
    if (m_sLocal.IsEmpty())
    {
      AfxMessageBox(_T("Please specify a valid local file"));
      pDX->PrepareEditCtrl(IDC_LOCAL);
      pDX->Fail();
    }
    if (m_nConnection == static_cast<int>(CFTPTransferer::ConnectionType::UseProxy) && m_sProxy.GetLength() == 0)
    {
      AfxMessageBox(_T("Please enter a non-empty Proxy Server"));
      pDX->PrepareEditCtrl(IDC_PROXY_STRING);
      pDX->Fail();
    }
  }
}

#pragma warning(suppress: 26433 26440)
BEGIN_MESSAGE_MAP(CFTPDlg, CDialog) //NOLINT(modernize-avoid-c-arrays)
  ON_WM_PAINT()
  ON_WM_QUERYDRAGICON()
  ON_BN_CLICKED(IDC_DOWNLOAD, &CFTPDlg::OnDownload)
  ON_BN_CLICKED(IDC_UPLOAD, &CFTPDlg::OnUpload)
END_MESSAGE_MAP()

BOOL CFTPDlg::OnInitDialog()
{
  //Let the base class do its thing
  __super::OnInitDialog();

  SetIcon(m_hIcon, TRUE);
  SetIcon(m_hIcon, FALSE);

  return TRUE;
}

#pragma warning(suppress: 26434)
void CFTPDlg::OnPaint()
{
  if (IsIconic())
  {
    CPaintDC dc{this};
#pragma warning(suppress: 26490)
    SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);
    const int cxIcon{GetSystemMetrics(SM_CXICON)};
    const int cyIcon{GetSystemMetrics(SM_CYICON)};
    CRect rect;
    GetClientRect(&rect);
    const int x{(rect.Width() - cxIcon + 1) / 2};
    const int y{(rect.Height() - cyIcon + 1) / 2};
    dc.DrawIcon(x, y, m_hIcon);
  }
  else
    __super::OnPaint();
}

#pragma warning(suppress: 26434 26440)
HCURSOR CFTPDlg::OnQueryDragIcon()
{
#pragma warning(suppress: 26473)
  return static_cast<HCURSOR>(m_hIcon);
}

void CFTPDlg::OnDownload()
{
  if (UpdateData())
  {
    CFTPTransferDlg dlg;
#pragma warning(suppress: 26489)
    dlg.m_sRemoteFile = m_sRemote;
#pragma warning(suppress: 26489)
    dlg.m_sLocalFile = m_sLocal;
#pragma warning(suppress: 26489)
    dlg.m_sServer = m_sServer;
    dlg.m_bDownload = true;
    dlg.m_bBinary = (m_bAscii != FALSE);
    dlg.m_dbLimit = m_dbLimit;
    dlg.m_bPasv = (m_bPasv != FALSE);
    dlg.m_ConnectionType = static_cast<CFTPTransferer::ConnectionType>(m_nConnection);
#pragma warning(suppress: 26489)
    dlg.m_sProxyServer = m_sProxy;
    dlg.m_dwConnectionTimeout = m_dwConnectionTimeout;
    dlg.m_dwSendTimeout = m_dwSendTimeout;
    dlg.m_dwReceiveTimeout = m_dwReceiveTimeout;

    if (m_sUserName.GetLength())
    {
#pragma warning(suppress: 26489)
      dlg.m_sUserName = m_sUserName;
#pragma warning(suppress: 26489)
      dlg.m_sPassword = m_sPassword;
    }
    if (dlg.DoModal() == IDOK)
      AfxMessageBox(_T("File has been downloaded"), MB_OK | MB_ICONINFORMATION);
  }
}

void CFTPDlg::OnUpload()
{
  if (UpdateData())
  {
    CFTPTransferDlg dlg;
#pragma warning(suppress: 26489)
    dlg.m_sRemoteFile = m_sRemote;
#pragma warning(suppress: 26489)
    dlg.m_sLocalFile = m_sLocal;
#pragma warning(suppress: 26489)
    dlg.m_sServer = m_sServer;
    dlg.m_bDownload = false;
    dlg.m_bBinary = (m_bAscii != FALSE);
    dlg.m_dbLimit = m_dbLimit;
    dlg.m_bPasv = (m_bPasv != FALSE);
    dlg.m_ConnectionType = static_cast<CFTPTransferer::ConnectionType>(m_nConnection);
#pragma warning(suppress: 26489)
    dlg.m_sProxyServer = m_sProxy;
    dlg.m_dwConnectionTimeout = m_dwConnectionTimeout;
    dlg.m_dwSendTimeout = m_dwSendTimeout;
    dlg.m_dwReceiveTimeout = m_dwReceiveTimeout;

    if (m_sUserName.GetLength())
    {
#pragma warning(suppress: 26489)
      dlg.m_sUserName = m_sUserName;
#pragma warning(suppress: 26489)
      dlg.m_sPassword = m_sPassword;
    }
    if (dlg.DoModal() == IDOK)
      AfxMessageBox(_T("File has been uploaded"));
  }
}
